package ch.unige.solidify.service;

import java.security.Principal;
import javax.servlet.http.HttpServletRequest;

import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.context.request.RequestContextHolder;

@Component
public class SolidifyHttpRequestInfoProvider implements HttpRequestInfoProvider {

  private HttpServletRequest incomingRequest;

  private SolidifyHttpRequestInfoProvider(HttpServletRequest incomingRequest){
    this.incomingRequest = incomingRequest;
  }

  public MultiValueMap<String, String> getAuthorizationHeader() {
    final MultiValueMap<String, String> authorizationHeader = new LinkedMultiValueMap<>();
    if (RequestContextHolder.getRequestAttributes() != null && incomingRequest.getUserPrincipal() != null) {
       authorizationHeader.add(HttpHeaders.AUTHORIZATION, incomingRequest.getHeader(HttpHeaders.AUTHORIZATION));
    }
    return authorizationHeader;
  }

  public Principal getPrincipal() {
    if (RequestContextHolder.getRequestAttributes() != null) {
      return incomingRequest.getUserPrincipal();
    }
    return null;
  }
}
