package ch.unige.solidify.rest;

import java.util.ArrayList;
import java.util.List;

import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

public class FacetPage<T> extends PageImpl<T> {

  private final List<FacetResult> facetResults = new ArrayList<>();

  public FacetPage(List<T> content, List<FacetResult> facetResults, Pageable pageable, long total) {
    super(content, pageable, total);
    if (facetResults != null) {
      this.facetResults.addAll(facetResults);
    }
  }

  public FacetPage(List<T> content, Pageable pageable, long total) {
    super(content, pageable, total);
  }

  public FacetPage(List<T> content) {
    super(content);
  }

  public List<FacetResult> getFacetResults() {
    return this.facetResults;
  }
}
