package ch.unige.solidify.util;

import java.util.concurrent.TimeUnit;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.exception.SolidifyRuntimeException;

public class SolidifyTime {

  public static void waitInMilliSeconds(int delay) {
    try {
      TimeUnit.MILLISECONDS.sleep(delay);
    } catch (final InterruptedException e) {
      // Some useful details
      // See http://www.yegor256.com/2015/10/20/interrupted-exception.html
      // See https://rules.sonarsource.com/java/tag/multi-threading/RSPEC-2142
      Thread.currentThread().interrupt();
      throw new SolidifyRuntimeException("Interrupted exception", e);
    }
  }

  public static void waitInSeconds(int delay) {
    waitInMilliSeconds(1000 * delay);
  }

  public static void waitOneSecond() {
    waitInSeconds(1);
  }

  /**
   * This constructor should not be called
   */
  private SolidifyTime() {
    throw new IllegalStateException(SolidifyConstants.TOOL_CLASS);
  }

}
